﻿namespace U2UConsult.Win8.PrintingSample
{
    using Windows.UI.Xaml;
    using Windows.UI.Xaml.Controls;
    using Windows.UI.Xaml.Navigation;

    public sealed partial class MainPage : Page
    {
        private PrintServiceProvider printServiceProvider;

        public MainPage()
        {
            this.InitializeComponent();
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            // Assign print service provider.
            // Alternatively, pull it from an IoC container.
            this.printServiceProvider = new PrintServiceProvider();

            // Typically, you would register here.
            this.printServiceProvider.StatusChanged += this.PrintServiceProvider_StatusChanged;
        }

        private void PrintServiceProvider_StatusChanged(object sender, PrintServiceEventArgs e)
        {
            (this.DataContext as MainPageViewModel).Message = e.Message;
        }

        protected override void OnNavigatedFrom(NavigationEventArgs e)
        {
            // Here is where you should unregister automatically.
            this.printServiceProvider.StatusChanged -= this.PrintServiceProvider_StatusChanged;
        }

        /// <summary>
        /// Event handler for register button click.
        /// </summary>
        private void Register_Click(object sender, RoutedEventArgs e)
        {
            this.printServiceProvider.RegisterForPrinting(this, typeof(MainPrintPage), this.DataContext);
        }

        /// <summary>
        /// Event handler for print button click.
        /// </summary>
        private void Print_Click(object sender, RoutedEventArgs e)
        {
            this.printServiceProvider.Print();
        }
    }
}
